Getting Started with Accordion Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Accordion module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.accordion.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-accordion id="accordion"></smart-accordion>

    Host container (id matches appendTo on Smart.Accordion):

    <div id="accordionContainer"></div>

  5. Initialize after the module loads: define a const accordionOptions object, then either bind with Smart('#accordion', ...) on the semantic tag or use new Smart.Accordion({ ...accordionOptions, appendTo: '#accordionContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.accordion.js';
    
    	const accordionOptions = { expandMode: 'multiple' };
    
    	// Option A - semantic <smart-accordion> with id="accordion"
    	Smart('#accordion', class {
    		get properties() {
    			return accordionOptions;
    		}
    	});
    
    	// Option B - host div id="accordionContainer"
    	// const accordionInstance = new Smart.Accordion({
    	// 	...accordionOptions,
    	// 	appendTo: '#accordionContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myAccordion = new Smart.Accordion('#accordion', accordionOptions);
    	// document.body.appendChild(myAccordion);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Accordion('#accordion', accordionOptions) with appendChild, and document.createElement('smart-accordion') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Accordion({ ...options, appendTo: '#...' }); new Smart.Accordion('#accordion', accordionOptions) plus appendChild on the returned element; and document.createElement('smart-accordion') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myAccordion = new Smart.Accordion('#accordion', accordionOptions)):

	const accordionOptions = { expandMode: 'multiple' };
	const myAccordion = new Smart.Accordion('#accordion', accordionOptions);
	document.body.appendChild(myAccordion);
	

Create with document.createElement('smart-accordion'), assign properties (same as any custom element), then append:

	const accordionOptions = { expandMode: 'multiple' };
	const accordion = document.createElement('smart-accordion');
	Object.assign(accordion, accordionOptions);
	document.body.appendChild(accordion);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.accordion.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const accordionOptions = { expandMode: 'multiple' };
		const accordion = new Smart.Accordion({
			...accordionOptions,
			appendTo: '#accordionContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('accordion-container');
container.appendChild(accordion);
	

Remove from the DOM:

accordion.remove();
	

Set a property:

accordion.disabled = true;
accordion.theme = 'dark';
	

Get a property value:

const isDisabled = accordion.disabled;
const currentTheme = accordion.theme;
	

Invoke a method:

accordion.refresh();
accordion.focus();
	

Add event listener:

accordion.addEventListener('collapse', (event) => {
    console.log('collapse triggered:', event.detail.content);
});
	

Remove event listener:

const handleAccordionEvent = (event) => {
    console.log('collapse triggered:', event.detail.content);
};

accordion.addEventListener('collapse', handleAccordionEvent);
accordion.removeEventListener('collapse', handleAccordionEvent);
	

Common Use Cases

  • Expand specific item

    Programmatically open an accordion section

    accordion.expand(0); // Expand first item
  • Single expansion mode

    Allow only one panel open at a time

    accordion.expandMode = 'single';

Troubleshooting

How do I expand multiple items?
Set expandMode = 'multiple' to allow several panels to be open simultaneously.

Accessibility

The Accordion component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Accordion - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/accordion/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import AccordionModule from smart-webcomponents-angular/accordion: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { AccordionModule } from 'smart-webcomponents-angular/accordion';

4 Root component (standalone)

Add AccordionModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';

import { AccordionModule } from 'smart-webcomponents-angular/accordion';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ AccordionModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	
 
	ngAfterViewInit(): void {
		// afterViewInit code.
    }
	
	ngOnInit(): void {
		// onInit code.
		this.init();
	}
	
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-accordion as needed:

 <smart-accordion>
    <smart-accordion-item label="First Item">First Item Content.</smart-accordion-item>
    <smart-accordion-item label="Second Item">Second Item Content.</smart-accordion-item>
    <smart-accordion-item label="Third Item">Third Item Content.</smart-accordion-item>
    <smart-accordion-item label="Fourth Item">Fourth Item Content.</smart-accordion-item>
</smart-accordion>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put AccordionModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put AccordionModule from smart-webcomponents-angular/accordion on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { AccordionModule } from 'smart-webcomponents-angular/accordion';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, AccordionModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Expand specific item

    Programmatically open an accordion section

    accordion.expand(0); // Expand first item
  • Single expansion mode

    Allow only one panel open at a time

    accordion.expandMode = 'single';

Troubleshooting

How do I expand multiple items?
Set expandMode = 'multiple' to allow several panels to be open simultaneously.

Accessibility

The Accordion component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.